class Bandit : public Object
 {
  private:

   Player *player; // Pointer to player
   AR_ParticleGenerator *exhaust,*smoke,*explosion;
   float move_x,move_y,speed;

   void collisions()
    {
     // Collisions with player bullets
     for(int n=0;n<player->getTotalCannons();n++)
      {
       bullets = player->getCannon(n)->getBulletsP();
       for(int i=0;i<player->getTotalBullets(n);i++)
        if(bullets[i]->getAction() != AR::NONE)
         {
		  if(shield->getHealth() > 0)
           if(shield->hitTest(bullets[i]->getX(),bullets[i]->getY())) // Shield
	        { bullets[i]->hit(); shield->hit(bullets[0]); player->incBulletsHit(); }
          if(hitTest(bullets[i]->getX(),bullets[i]->getY()))          // Object
	       { bullets[i]->hit(); hit(bullets[i]); }
		 }
	  }

     // Collisions with player missiles//TODO fare direttamente con "hit()" in classe Missile...
     bullets = (Bullet **)player->getMissileLauncher()->getMissilesP();
     for(int i=0;i<player->getMissileLauncher()->getTotalMissiles();i++)
      if(bullets[i]->getAction() != AR::NONE)
       {
		if(shield->getHealth() > 0)
         if(shield->hitTest(bullets[i]->getX(),bullets[i]->getY())) // Shield
	      { bullets[i]->hit(); shield->hit(bullets[0]); player->incBulletsHit(); }
        if(hitTest(bullets[i]->getX(),bullets[i]->getY()))          // Object
	     { bullets[i]->hit(); hit(bullets[i]); }
	   }
	}

  public:

   Bandit(string filename, AR_Display *display, AR_Sprite *p_particles, AR_Sprite *p_cannons, AR_Sprite *p_shield, AR_Sprite *p_lights, Object *p = NULL) : Object(filename,display,p_particles,p_cannons,p_shield,p_lights,p,1)
    {
     exhaust   = generators[0];
     smoke     = generators[1];
     explosion = generators[2];
     reset();
	}

   ~Bandit() { }

   void run()
    {
     float cannon_angle;

     if(!enable) return;

     Object::run();
     shield->setX(x); shield->setY(y);
     cannons[0]->setX(x);
     cannons[0]->setY(y);

	 cannon_angle = AR_Util::degrees(atan2(player->getY()-y,player->getX()-x));
     cannons[0]->setAngle(cannon_angle);
     if(AR_Util::random(40) == 0 && action==AR::ATTACK) cannons[0]->shoot();     

     // Aim to direction
     float dx,dy,angle,cosa,sina;

     dx = move_x-x;
	 dy = move_y-y;
	 angle = atan2(dy,dx);	 
     cosa = cos(angle);
     sina = -sin(angle);

     if(action==AR::ESCAPE) { if(sqrt(dx*dx+dy*dy) < 100) action = AR::NONE;   }
     if(action==AR::ATTACK) { if(sqrt(dx*dx+dy*dy) < 300) action = AR::ESCAPE; }
     if(action==AR::NONE)   { action = AR::ATTACK;                             }

     if(action==AR::ATTACK) { move_x=player->getX(); move_y=player->getY() - 400; speed = 2; }
     if(action==AR::ESCAPE) { move_x=player->getX()+AR_Util::random(4000)-2000; move_y=0; speed = 3; }

     if(cosa > 0)
      if(speed_x > speed*cosa) acceleration_x = -0.02*cosa;
      else                     acceleration_x =  0.02*cosa;
     else
      if(speed_x > speed*cosa) acceleration_x =  0.02*cosa;
     else                      acceleration_x = -0.02*cosa;

     if(sina > 0)
      if(speed_y > speed*sina) acceleration_y = -0.03*sina;
      else                     acceleration_y =  0.03*sina;
     else
      if(speed_y > speed*sina) acceleration_y =  0.03*sina;
      else                     acceleration_y = -0.03*sina;

     exhaust->setSource(x,y);
     explosion->setSource(x,y+AR_Util::random(6)-3);
     smoke->setSource(x-32,y+AR_Util::random(6)-3);

     if(health > 0) collisions();

	 if(health <= 0)
	  {
	   acceleration_y = -0.3; if(y>5000 && enable==true) { setEnable(false); (*player->getRemainingEnemiesP())--; }
	   explosion->setCurrentFrame(1);
	   explosion->setStartSpeed(200,150);
	   explosion->setParticleATime(50);
	   explosion->start(x,y,1,1);
	  }
	}

   void draw()
    {
	 if(!enable) return;

	 exhaust->draw();
	 Object::draw();
	 for(int i=0;i<total_cannons;i++) cannons[i]->draw();
	 explosion->draw();
	 smoke->draw();
     shield->draw();
	 if(player->getScanEnemiesHealth())  drawHealthbar();
	 if(player->getScanEnemiesShields()) drawShieldsbar();
	}

   void hit(Bullet *b)
    {
	 Object::hit(b);
	 player->incBulletsHit();
     smoke->setGenerateTime(health*4);
     explosion->setAcceleration(getAccelerationX(),getAccelerationY());
     explosion->start(b->getX(),b->getY(),1,1);
     if(health==0) (*player->getScoreP())+=200;
	}

   void reset()
    {
	 // Reset variables to default
	 Object::reset();
	 move_x         = 0;
	 move_y         = 0;
	 speed          = 3;
	 health         = 20;
	 speed_x        = -0.05;
	 speed_y        = -0.02;
 	 acceleration_x = 0.0015;
	 acceleration_y = -0.00002;
	 exhaust->setAcceleration(acceleration_x,acceleration_y);
	 exhaust->setCurrentFrame(1);
     exhaust->setStartAlpha(40);
     exhaust->setStartScale(0,0);
     exhaust->setScaleStep(0.01,0.01);
     exhaust->start(x,y,2);

	 smoke->setAcceleration(0.01,-0.0001);
	 smoke->setCurrentFrame(2);

	 explosion->setAcceleration(0,0);
	 explosion->setCurrentFrame(5);
	 explosion->setParticleATime(10);
	 explosion->setStartSpeed(100,100);
	 explosion->setRandomEnable(true);
	 explosion->setStartAlpha(250);
	 explosion->setAlphaStep(10);
	 explosion->setStartLife(0);

     cannons[0]->setWeapon(AR::CANNON_GENERIC);
     cannons[0]->setBulletDamage(1);
	 cannons[0]->setCurrentFrame(0);
	 cannons[0]->setHullFrame(8);
	 cannons[0]->setAimFrame(1);
	 cannons[0]->setBulletFrame(1);
	 cannons[0]->setFriction(0.003,0.003);
     cannons[0]->setPower(9.0);
     cannons[0]->setReloadTime(25);
     cannons[0]->setLife(160);
     cannons[0]->setX(x);
     cannons[0]->setY(y);
     cannons[0]->setEnableTargetting(false);
	}

   void restart(bool enable = true)
    {
	 // Restart object
	 reset();
	 if(!enable) return;
	 if(AR_Util::random(1)) setX(-1300 + AR_Util::random(1000));
     else                   setX(2900 + AR_Util::random(1000));
     setY(AR_Util::random(200));
     startAnimation(1,3);
     setEnable(true);
	}

   void activateShield(bool v)
    {
     if(v)
      {
	   shield->setHealth(8);
	   shield->setEnable(true);
      }
	}

   void setPlayerP(Player *player) { this->player = player; }

 };
