class MissileLauncher : public Cannon
 {
  private:

   Missile **missiles;
   int total_missiles;

  public:

   MissileLauncher(string filename, AR_Display *display, int total_missiles, AR_Sprite *p = NULL) : Cannon(filename,display,0,p)
    {
     this->total_missiles = total_missiles;
	 missiles = (Missile **)malloc(sizeof(Missile *)*total_missiles);
	 for(int i=0;i<total_missiles;i++) missiles[i] = new Missile("",display,(Missile *)this);
     reset();
	}

   ~MissileLauncher() { }

   void shoot(float *target_x, float *target_y)
    {
	 int max;

     if(weapon == AR::NO_CANNON) return;
     if(can_shoot)
      {
	   can_shoot = false; reload_count = 0;
	   max = bullet_a_time;
	   for(int i=0;i<total_missiles;i++)
        if(missiles[i]->getAction() == AR::NONE)
         {
	      missiles[i]->shoot(getX(),getY(),getAngle()+AR_Util::random(8)-4,power,life,friction_x,friction_y,acceleration_x,acceleration_y,gravity_x,gravity_y,target_x,target_y);
	      missiles[i]->setCurrentFrame(bullet_frame);
	      missiles[i]->setDamage(bullet_damage);
	      bullets_fired++;
	      can_shoot    = false;
	      reload_count = 0;
	      if(max==1) break; else max--;
         }
	  }
	}

    void debug()
    {
     for(int i=0;i<total_missiles;i++) missiles[i]->debug();
	}

   void run()
    {
	 AR_Sprite::run();
	 for(int i=0;i<total_missiles;i++) missiles[i]->run();
     if(!can_shoot) { if(reload_count == reload_time) can_shoot = true; reload_count++; }
	}

   void draw()
    {
     for(int i=0;i<total_missiles;i++) missiles[i]->draw();
     Cannon::draw();
	}

   void reset()
    {
	 // Reset variables to default
	 Cannon::reset();
    }

   void restart()
    {
	 Cannon::restart();
	 reload_count = reload_time;
	 for(int i=0;i<total_missiles;i++) missiles[i]->reset();
	}

   void setScrollXYP(float *scroll_x, float * scroll_y)
    {
	 Cannon::setScrollXYP(scroll_x,scroll_y);
	 for(int i=0;i<total_missiles;i++)
	  {
	   missiles[i]->setScrollXP(scroll_x);
	   missiles[i]->setScrollYP(scroll_y);
      }
	}

   int getTotalMissiles()   { return total_missiles; }

   Missile **getMissilesP() { return missiles; }

 };
